module oc_dotme_mod
  use oc_global_mod
  use oc_filealgebra_mod
  use oc_llist_mod
	use oc_mpi_combine_mod
  implicit none
  integer, private :: ocmaxmem
  integer, private :: ocimpi

contains

	subroutine oc_dotme_init(impi,maxmem)
		integer                     :: impi 
    integer, optional           :: maxmem

		ocimpi=impi
		ocmaxmem=0;     if(present(maxmem))   ocmaxmem= maxmem

	end subroutine oc_dotme_init

  !----------------------------------------------------------------
  integer function oc_dotme(adj,add,x_,yy_,op1,op2,op3,op4,op5,op6,op7,op8,op9)
    integer, external, optional :: op3,op4,op5,op6,op7,op8,op9
		real                        :: eps
    logical, intent (in)        :: adj, add
    character(len=128)          :: x_, yy_, uu_,name

!---------------------------------------------------------------------
    interface
       integer function op1( adj,add, x_,yy_, op3,op4,op5,op6,op7,op8,op9) result(st)
         integer, external, optional :: op3,op4,op5,op6,op7,op8,op9
         logical, intent (in)        :: adj, add
         character(len=128)          :: x_, yy_
       end function op1
       integer function op2( adj,add, x_,yy_, op3,op4,op5,op6,op7,op8,op9) result(st)
         integer, external, optional :: op3,op4,op5,op6,op7,op8,op9
         logical, intent (in)        :: adj, add
         character(len=128)          :: x_, yy_
       end function op2
    end interface
! op1=weimig op2=oc_guber_prec
!---------------------------------------------------------------------

	eps=.1

	name='uu_';if(ocimpi==0) uu_=oc_clone(F, x_,name,ocmaxmem)

	call oc_chain(op1,op2,adj,add, x_,yy_,uu_,op3,op4,op5,op6,op7,op8,op9)

  end function oc_dotme
  !----------------------------------------------------------------
end module oc_dotme_mod











