module wei_fk_share_mod
use wei_var_type
use wei_down
use wei_obj_S
use wei_kmap
implicit none




contains






 subroutine dsr_init(max,n,kzko,tkzko,exp_kzko,ikzko,dkxko,nkxko,idkzko,rdkzko)
    real,    intent(in) :: max
    integer, intent(in) :: n
    integer             :: er
    integer             :: i,m,nkxko
    real                :: kxko,kz,dkxko,rdkzko,idkzko
    real, pointer       :: exp_kzko(:),ikzko(:)
    complex, pointer   :: kzko(:),tkzko(:)

    allocate( kzko(n),stat=er)
    if(er/=0) call seperr('cant allocate  kzko')
    allocate(tkzko(n),stat=er)
    if(er/=0) call seperr('cant allocate tkzko')
    allocate(exp_kzko(n),ikzko(n))
    call add_mem(n*2)

    dkxko = max/(n-1)
    nkxko = n
    m=n/max

    !!                    ____________
    !!   kz         1    /     | kx |2          kx
    !! i -- dz = -i -   /  1 - | -- |  dz   0 < -- < 1
    !!   ko         2 \/       | ko |           ko
    !!
    do i=1,m
       kxko    = 0. +     1.0 * (i  -1)/(  m-1) !! kx/ko=0...1
       kzko(i) = - (0,+1) * sqrt(1-kxko**2)
    end do

    !!                    ____________
    !!   kz         1    / | kx |2              kx
    !! i -- dz = -  -   /  | -- | - 1  dz   1 < -- < max
    !!   ko         2 \/   | ko |               ko
    !!
    do i=m+1,n
       kxko    = 1. + (max-1) * (i-m-1)/(n-m-1) !! kx/ko=1...max
       kzko(i) = - (+1,0) * sqrt(kxko**2-1)
    end do

    idkzko=1./(n-1)
    do i=1,n
       kxko    = 0. +     1.0 * (i  -1)/(  n-1) !! kx/ko=0...1
       kz= sqrt(1.-kxko)
       ikzko(i)=kz
    end do

    rdkzko=(max-1.)/(n-1)
    do i=1,n
       kxko    = 1. +     (max-1.) * (i  -1)/(  n-1) !! kx/ko=0...1
       kz= sqrt(kxko-1.)
       exp_kzko(i)=kz
    end do



    kzko = .5 * kzko
  end subroutine dsr_init



 subroutine calc_comp_depend_vars(w,slow_0,ko,kx,ky,sign,source,izs,ifk)
  real :: ko,w,slow_0
  real, pointer :: kx(:,:),ky(:,:)
  integer :: sign ,izs,ifk
  logical :: source


  if(source) then
    slow_0=slo%sz_s(izs,ifk)
    kx=>kmap%ksx
    ky=>kmap%ksy
    sign=1
  else
    slow_0=slo%sz_r(izs,ifk)
    kx=>kmap%krx
    ky=>kmap%kry
    sign=-1
  end if
    ko = 2* slow_0 * w



 end subroutine




 subroutine calc_sign_depend_vars(fract,tkzko,dz,kzko,ko)
  real :: fract,dz,ko
  complex :: tkzko(:),kzko(:)

    if(down%opsign==goB2T) then
       tkzko=conjg(kzko)
       fract=.5*dz*ko
    else
       tkzko=kzko
       fract=-.5*dz*ko
    end if

end subroutine








end module
