module wei_mig_memsave
  use wei_mig_base
 implicit none

contains
  integer function weimigsave(adj,add,mod_,dat_,SLop,WCop,FKop,FXop,IGop,op6,op7,op8,op9)
  logical,            intent(in) :: adj,add
  character(len=128), intent(in) :: mod_,dat_
    integer,external,optional :: WCop,FKop,FXop,IGop,op6,op7,op8,op9
    integer :: izb,iwb
    integer :: st
     complex, allocatable,target :: buffer(:,:,:,:,:)
#ifdef DEBUG
    character(len=128), parameter :: unit='weimig'
#endif
    interface !!----------------------------------------------
       integer function SLop() result(st)
       end function SLop
    end interface !!------------------------------------------
#ifdef DEBUG
    if(run%debug) call in(unit)
#endif
     var%dzb=down%rsep%d(5)

if( run%mem_save<2)&
   call seperr("calling weimigsave when mem_save < 2 option not specified on commandline")

#ifdef DEBUG
       if(run%debug) call in('migration')
#endif

   if(.not. weimig_begin(adj,add,mod_,dat_)) &
     call seperr("trouble doing migration begin")

      call del_mem(size(down%block))
      deallocate(down%block)
      allocate(buffer(down%wsep%n(1),down%wsep%n(2),down%wsep%n(3),down%wsep%n(4),1))
      call add_mem(size(buffer))
      bW%bin=>buffer
      D%bin=>buffer
      R%bin=>buffer
      if(run%mem_save==2) R%bin=>tmp_on(:,:,:,:,:1)


       !----------------------------------------------------------
       call set_blocks(n_wb=size(down%iw_first),n_zb=down%rsep%n(5)/down%nzs,n_blocks=down%nwb*down%nzb)
       call data_copy(D,bW)           !! copy the data at the top
       call to_history("fblock",0,R%tag) 
       wbA: do iwb=1,down%nwb
          if(.not. data_read(bW,iwb))&      !! read  data at block top
            call erexit("trouble reading data")
          zbA: do izb=1,down%nzb       
            call setup_var_block(iwb,izb)
            call slowness_read(S,izb) !! read a slowness block
            st = SLop()               !! setup sS, sR, s(z)
            if(run%verb) call wei_followup(izb,iwb)
            if(run%mem_save>2) call store_w(bw%bin)
            call weiimgW2R(1,1,1,R%bin,bW%bin,IGop)
            call image_write(R,izb,(iwb/=1 .or. down%add .or. run%share_image)) !! write image block
            if(run%mem_save>2) call grab_w(bw%bin)
            call weikxmig(bW%bin,1,1,1,WCop,FKop,FXop)
          end do zbA
          call to_history("fblock",iwb,R%tag) 
       end do wbA
       !----------------------------------------------------------
#ifdef DEBUG
       if(run%debug) call out('migration')
#endif

   if(.not. weimig_end()) &
     call seperr("trouble doing migration end")

#ifdef DEBUG
    if(run%debug) call out(unit)
#endif
    weimigsave=OK
  end function weimigsave


end module 

