module wei_mig_mid_basic
  use wei_mig_base
 implicit none

contains
  !----------------------------------------------------------------
  integer function weimig(adj,add,mod_,dat_,SLop,  WCop,FKop,FXop,IGop,op6,op7,op8,op9)
  logical,            intent(in) :: adj,add
  character(len=128), intent(in) :: mod_,dat_
    integer,external,optional :: WCop,FKop,FXop,IGop,op6,op7,op8,op9
    integer :: izb,iwb
    integer :: st
     complex, allocatable,target :: buffer(:,:,:,:,:)
#ifdef DEBUG
    character(len=128), parameter :: unit='weimig'
#endif
    interface !!----------------------------------------------
       integer function SLop() result(st)
       end function SLop
    end interface !!------------------------------------------
#ifdef DEBUG
    if(run%debug) call in(unit)
#endif
    logical :: junkt
    integer :: t1,t2,t3


   if(.not. weimig_begin(adj,add,mod_,dat_))&
     call seperr("trouble doing migration begin")

    if(run%mem_save >1) &
     call seperr("mem_save >2 must use mig_mem_save")
  

    if(down%order(1:2)=="OF") then
       weimig=weimigof(SLop,  WCop,FKop,FXop,IGop)
    else 
       weimig=weimigoz(SLop,  WCop,FKop,FXop,IGop)
    end if

   if(.not. weimig_end())&
     call seperr("trouble doing migration end")

#ifdef DEBUG
    if(run%debug) call out(unit)
#endif
    weimig=OK
    
  end function weimig
  integer function weimigof(SLop,WCop,FKop,FXop,IGop,op6,op7,op8,op9)
    integer,external,optional :: WCop,FKop,FXop,IGop,op6,op7,op8,op9
    integer :: izb,iwb
    integer :: st,ierr,t1,t2,t3,i
    logical :: junkt
#ifdef DEBUG
    character(len=128), parameter :: unit='weimigof'
#endif
    interface !!----------------------------------------------
       integer function SLop() result(st)
       end function SLop
    end interface !!------------------------------------------
     var%dzb=down%rsep%d(5)

   junkt=setup_next_timer("IO timer",t1)
   junkt=setup_next_timer("Slow timer",t2)
   junkt=setup_next_timer("Down timer",t3)

    if(down%order(1:2)/="OF") &
      call seperr("OF not specified weimigof called")

    if(down%adj) then !! MIGRATION
#ifdef DEBUG
       if(run%debug) call in('migration')
#endif
       !----------------------------------------------------------
       call set_blocks(n_wb=size(down%iw_first),n_zb=down%rsep%n(5)/down%nzs,n_blocks=down%nwb*down%nzb)
      call start_timer_num(t1)
       call data_copy(D,bW)           !! copy the data at the top
      call stop_timer_num(t1)
       wbA: do iwb=1,down%nwb
      call start_timer_num(t1)
          if(.not. data_read(bW,iwb))&      !! read  data at block top
            call erexit("trouble reading data")
      call stop_timer_num(t1)
          zbA: do izb=1,down%nzb       
            call setup_var_block(iwb,izb)
      call start_timer_num(t2)
            call slowness_read(S,izb) !! read a slowness block
            st = SLop()               !! setup sS, sR, s(z)
      call stop_timer_num(t2)
            call wei_followup(izb,iwb)
            R%bin=0.;
      call start_timer_num(t3)
                call wmigRD(izb,iwb,down%nzs,WCop,FKop,FXop,IGop) !! trash W
      call stop_timer_num(t3)
 
      call start_timer_num(t1)
            call image_write(R,izb,.true.)
      call stop_timer_num(t1)
          end do zbA
       end do wbA

      do i=0,run%m_nth-1
         call mpi_barrier(mpi_comm_world,ierr)
         write(0,*) "THREAD NUMBER",i
         if(i==run%m_ith) call print_timers()
      end do

       !----------------------------------------------------------
#ifdef DEBUG
       if(run%debug) call out('migration')
#endif
    else         !! MODELING
#ifdef DEBUG
       if(run%debug) call in('modeling')
#endif
       !----------------------------------------------------------
       call data_assign(bW,(0.,0.))    !! start with no data
       call set_blocks(n_wb=size(down%iw_first),n_zb=down%rsep%n(5)/down%nzs,n_blocks=down%nwb*down%nzb)
       wbF: do iwb=1,down%nwb
           if(.not. data_read(bW,iwb))&      !! read  data at block bottom
             call erexit("trouble reading data")
           zbF: do izb=down%nzb,1,-1    
            call setup_var_block(iwb,izb)
             call    image_read(R,izb) !! read image block
             call slowness_read(S,izb) !! read a slowness block
             st = SLop()               !! setup sS,sR, s(z)
             call wei_followup(izb,iwb)
                call wmigRD(izb,iwb,down%nzs,WCop,FKop,FXop,IGop) !! trash W
            end do zbF
            if(.not. data_write(bW,iwb))& !! write data at block top
              call erexit("trouble writing data")
!             call to_history("fblock",iwb,D%tag) 
        end do wbF
       call data_add(bW,D)          !! add U.C. wfld to data
       !----------------------------------------------------------
#ifdef DEBUG
       if(run%debug) call out('modeling')
#endif
    end if
#ifdef DEBUG
    if(run%debug) call out(unit)
#endif
    weimigof=OK
  end function weimigof


  !----------------------------------------------------------
  integer function weimigoz(SLop,WCop,FKop,FXop,IGop,op6,op7,op8,op9)
    integer,external,optional :: WCop,FKop,FXop,IGop,op6,op7,op8,op9
    integer :: izb,iwb
    integer :: st
#ifdef DEBUG
    character(len=128), parameter :: unit='weimigoz'
#endif
    interface !!----------------------------------------------
       integer function SLop() result(st)
       end function SLop
    end interface !!------------------------------------------

    if(down%order(1:2)/="OZ") &
      call seperr("OZ not specified weimigos called")

       var%dzb=down%rsep%d(5)
       call set_blocks(n_wb=size(down%iw_first),n_zb=down%rsep%n(5),n_blocks=down%nwb*down%nzb)
    if(down%adj) then !! MIGRATION
#ifdef DEBUG
       if(run%debug) call in('migration')
#endif
       !----------------------------------------------------------
       call data_copy(D,bW)         !! copy the data at the top
       zbA: do izb=1,down%nzb        
          call    image_read(R,izb) !! read image block
          call slowness_read(S,izb) !! read a slowness block
          st = SLop()               !! setup sS, sR, s(z)
!          call to_history("fblock",0,R%tag) 
          wbA: do iwb=1,down%nwb
            call setup_var_block(iwb,izb)
             call wei_followup(izb,iwb)
             if(.not. data_read(bW,iwb))& !! read  data at block top
               call erexit("trouble reading data")
               call wmigRD(izb,iwb,down%nzs,WCop,FKop,FXop,IGop) !! trash W
             if(.not. data_write(bW,iwb))&  !! write data at block bottom
              call erexit("trouble writing data")
             call to_history("fblock",iwb,R%tag) 
          end do wbA
            call image_write(R,izb)     !! write image block
       end do zbA
       !----------------------------------------------------------
#ifdef DEBUG
       if(run%debug) call out('migration')
#endif
    else         !! MODELING
#ifdef DEBUG
       if(run%debug) call in('modeling')
#endif
       !----------------------------------------------------------
       call data_assign(bW,(0.,0.)) !! start with no data
       zbF: do izb=down%nzb,1,-1
          call    image_read(R,izb) !! read image block
          call slowness_read(S,izb) !! read a slowness block
          st = SLop()               !! setup sS,sR, s(z)
          wbF: do iwb=1,down%nwb
            call setup_var_block(iwb,izb)
            call wei_followup(izb,iwb)
             if(.not. data_read(bW,iwb))& !! read  data at block bottom
               call erexit("trouble reading data")
                call wmigRD(izb,iwb,down%nzs,WCop,FKop,FXop,IGop) !! trash W
             if(.not. data_write(bW,iwb))&!! write data at block top
              call erexit("trouble writing data")
          end do wbF
       end do zbF
       call data_add(bW,D)          !! add U.C. wfld to data
       !----------------------------------------------------------
#ifdef DEBUG
       if(run%debug) call out('modeling')
#endif
    end if
#ifdef DEBUG
    if(run%debug) call out(unit)
#endif
    weimigoz=OK
  end function weimigoz




end module 

