module wei_mig_var
  use wei_mig_base
implicit none

contains


  !----------------------------------------------------------
  integer function weimigvar(adj,add,mod_,dat_,SLop,WCop,FKop,FXop,IGop,op6,op7,op8,op9)
    logical,            intent(in) :: adj,add
    character(len=128), intent(in) :: mod_,dat_
    integer,external,optional :: WCop,FKop,FXop,IGop,op6,op7,op8,op9
    integer :: izb,iwb,iws,izs,ith
    integer :: st,izdone,nzb,nzs
#ifdef DEBUG
    character(len=128), parameter :: unit='weimigvar'
#endif
    interface !!----------------------------------------------
       integer function SLop() result(st)
       end function SLop
    end interface !!------------------------------------------
     var%dzb=down%rsep%d(5)

    if(down%order(1:3)/="VAR") then
      if(run%m_ith==0) write(0,*) "ORDER",down%order
      call seperr("VAR not specified weimigvar called")
     end if


#ifdef DEBUG
       if(run%debug) call in('migration')
#endif

   if(.not. weimig_begin(adj,add,mod_,dat_))&
     call seperr("trouble doing migration begin")




  izb=0
  do iwb=1,size(var%z_samp)
      izb=izb+ceiling(size(var%z_samp(iwb)%dz)/(1.0*down%nzs))
    end do
    call set_blocks(n_wb=size(down%iw_first),n_blocks=izb)


    if(down%adj) then !! MIGRATION
#ifdef DEBUG
       if(run%debug) call in('migration')
#endif
       !----------------------------------------------------------
       call data_copy(D,bW)           !! copy the data at the top
       wbA: do iwb=1,down%nwb
          if(.not. data_read(bW,iwb))&      !! read  data at block top
             call erexit("trouble reading data")
          call var_samp_iw(iwb)
          call var_slow(iwb)
          call set_blocks(n_zb=ceiling(1.0*size(var%z_samp(iwb)%dz)/(1.0*down%nzs)))
          izdone=0;izb=0
          nzb=ceiling(real(size(var%z_samp(iwb)%dz))/real(down%nzs))
          zbA: do while(izdone< size(var%z_samp(iwb)%dz))
            izb=izb+1
            call setup_var_block(iwb,izb)
            nzs=min(down%nzs,size(var%z_samp(iwb)%dz)-izdone)
            R%bin=cmplx(0.,0.)
            call slowness_read(S,izb,nzs) !! read a slowness block
            st = SLop()               !! setup sS, sR, s(z)
            call wei_followup(izb,iwb)

            call wmigRD(izb,iwb,nzs,WCop,FKop,FXop,IGop) !! trash W
            call image_write(R,izb,iwb/=1.or.down%add .or. run%share_image,iwb,nzs)!!write image block
            izdone=izdone+nzs

          end do zbA
!          call to_history("fblock",iwb,R%tag)
       end do wbA
       !----------------------------------------
  else
    call seperr("no model for migvar")
  end if





#ifdef DEBUG
       if(run%debug) call out('migration')
#endif

   if(.not. weimig_end())&
     call seperr("trouble doing migration end")

#ifdef DEBUG
    if(run%debug) call out(unit)
#endif
    weimigvar=OK
  end function weimigvar




end module 

