module wei_var_samp
  use wei_external
  use wei_down_type
  use wei_var
  implicit none


contains

subroutine create_modified_slowness(tag_in,tag_out,velocity,nv,ov,dv,dz,zloc)
character(len=128) :: tag_in,tag_out
integer :: sample_per
integer :: n(3)
integer :: ipos
real :: d(3),freq,min_z,max_z
real :: o(3),z,zstep
real :: dz(:),zloc(:)
character(len=128) :: label
real, allocatable :: in_slice(:,:,:),out_slice(:,:)
integer npts,inew
logical :: changed,velocity
integer :: iz,iin,nv_in(2)
real :: fb,fe,min_dz,neg,mys,ov(3),dv(3)
integer :: ib,ie,j,i,jb,je,icur,iread,nv(3)
integer, external :: sseek,sreed,srite





!NOW TIME WRITE OUR NEW VELOCITY/SLOWNESS FIELD TO DISK
!
!
! THIS CAN BE TRICKY....
!
!
! When sample size is smaller than slowness sampling we will
! just do linear interpolation
!
! When it is larger than slowness sampling we will take an
! average  of all of the full samples covered by the jump
! plus fractional portions of other layers
!

allocate(in_slice(nv(1),nv(2),2))
allocate(out_slice(nv(1),nv(2)))
call add_mem(size(in_slice)+size(out_slice))
if(0/= sseek(tag_out,0,0)) &
  call seperr("trouble with initial seek on output in variable slow")
if(zloc(2)< zloc(1))  then
 neg=-1.
else
 neg=1.;
end if

!WHEN ADJOINT THIS SHOULD ALSO FlIP THE SlOWNESS FIELD


do i=1,size(zloc)
  if(neg==1) then
    fb=(zloc(i)-ov(3))/dv(3)+1;  ib=fb; fb=fb-ib
    fe=(zloc(i)+dz(i)-ov(3))/dv(3)+1;ie=fe; fe=fe-ie
  else
    fe=(zloc(i)-ov(3))/dv(3)+1;  ie=fe; fe=fe-ie
    fb=(zloc(i)-dz(i)-ov(3))/dv(3)+1;ib=fb; fb=fb-ib
  end if


  mys=0.
  jb=ib+1;je=ie+1
  if(ib<1) then
    ib=1; jb=1
  end if
  if(ib>=nv(3))then
   ib=nv(3)-1; jb=nv(3)-1
  end if
  if(ie>=nv(3))then
   ie=nv(3)-1; je=nv(3)-1
  end if

  if(ib-1 .ne. sseek_block(trim(tag_in),ib-1,nv(1)*nv(2)*4,0)) &
   call seperr("trouble with  seek 1 in variable slow construction")
  if( size(in_slice)*4 .ne.sreed(trim(tag_in),in_slice,size(in_slice)*4)) then
    write(0,*) "From tag",trim(tag_in),"seeked",ib-1," of ",nv(1)*nv(2)*4
    write(0,*) zloc(i),ov(3),dz(i)
    call seperr("trouble with reed 1 in variable slow construction")
  end if
  iin=ib

  !add in the first portion
  out_slice=((1.-fb)*in_slice(:,:,1)+fb*in_slice(:,:,2))*(1.-fb)*dv(3)
  mys=mys+dv(3)*(1.-fb)


  !add in middle suff
  do j=ib+1,ie-1
     if(j>iin+1) then
      if(j-1 .ne. sseek_block(trim(tag_in),j-1,nv(1)*nv(2)*4,0))&
   call seperr("trouble with  seek 2 in variable slow construction")
      if(size(In_slice)*4 .ne. sreed(trim(tag_in),in_slice,size(in_slice)*4)) &
 call seperr("trouble with reed 2 in variable slow construction")
     iin=j
     end if
     out_slice=out_slice+dv(3)*in_slice(:,:,1+j-iin)
     mys=mys+dv(3)
  end do

  !add in the end stuff
  if(ie/=iin) then
    if(ie-1 .ne. sseek_block(trim(tag_in),ie-1,nv(1)*nv(2)*4,0))&
      call seperr("trouble with  seek 3 in variable slow construction")
    if(size(in_slice)*4 .ne. sreed(trim(tag_in),in_slice,size(in_slice)*4)) &
      call seperr("trouble with reed 3 in variable slow construction")

iin=ie
  end if
  out_slice=out_slice+((1.-fe)*in_slice(:,:,1)+fe*in_slice(:,:,2))*(fe)*dv(3)
  mys=mys+dv(3)*fe

  out_slice=out_slice/mys

  if(.not. velocity) out_slice=1./out_slice
  if(size(out_slice)*4 .ne. srite(trim(tag_out),out_slice,size(out_slice)*4))&
   call seperr("trouble with write in variable slow construction")
end do
if(0/= sseek(trim(tag_out),0,0)) &
  call seperr("trouble with final seek of output in varaible slow construct")
call del_mem(size(out_slice)+size(in_slice))
deallocate(out_slice,in_slice)


end subroutine



end module
