!HANDLE FFTS
module wei_fft
  !! FFTW
  !! used for data(mx,my,hx,hy,w)

!IF WE AREN'T USING FFTW FAKE IT WITH SU'S PFFT


  use wei_down
  use wei_run
  use wei_flags
  use wei_attr
  !---------------
  implicit none
  integer*8,pointer,private,save :: planF(:),planI(:),extraF(:),extraI(:)
  complex, private,allocatable, save :: junk(:,:,:,:,:)
  real, private,save :: in123
contains
  !----------------------------------------------------------------
  !INITIALIZE THE FFT
  subroutine weifft_init(wfld)
    complex :: wfld(:,:,:,:,:)
    integer :: i,j,k
#ifdef DEBUG
    character(len=128), parameter :: unit='weifft_init'
    if(run%debug) call in(unit)
#endif

   allocate(planF(size(wfld,5)))
   allocate(planI(size(wfld,5)))


in123=sqrt(1./real(product(down%wsep%n(1:4))))

   do i=1,size(wfld,5)
     call sfftw_plan_dft(planF(i),4,down%wsep%n,wfld(1,1,1,1,i),wfld(1,1,1,1,i),&
       FFTW_FORWARD,FFTW_PATIENT)
     call sfftw_plan_dft(planI(i),4,down%wsep%n,wfld(1,1,1,1,i),wfld(1,1,1,1,i),FFTW_BACKWARD,FFTW_PATIENT)
   end do

   if(run%fk_extra >0) then
     allocate(extraF(run%o_nth*run%fk_extra))
     allocate(extraI(run%o_nth*run%fk_extra))
     do k=1,run%fk_extra
       do j=1,run%o_nth
          i=size(tmp_on,5)-k*run%o_nth+j
!          call sfftw_plan_dft(extraF(j+(k-1)*run%o_nth),4,down%wsep%n,tmp_on(1,1,1,1,i),tmp_on(1,1,1,1,i),&
!           FFTW_FORWARD,FFTW_PATIENT)
          call sfftw_plan_dft(extraI(j+(k-1)*run%o_nth),4,down%wsep%n,tmp_on(1,1,1,1,i),tmp_on(1,1,1,1,i),FFTW_BACKWARD,FFTW_PATIENT)
        end do
     end do 
   end if

#ifdef DEBUG
    if(run%debug) call out(unit)
#endif
  end subroutine weifft_init





  !----------------------------------------------------------------
  !! forward extra FFT
  subroutine weifft_e(ith,ipart,data)
    integer, intent(in) :: ith,ipart
    complex, dimension(:,:,:,:,:) :: data
    integer :: imx,imy,ndim
    integer :: iplan,i3,i1,n1,n2,i2,i4
    integer :: nd(4),nf(4)
#ifdef DEBUG
    character(len=128), parameter :: unit='weifft'
    if(run%depar) call in(unit)
#endif
#ifdef SEP_TIMER
       if(run%m_ith==0 .and. ith==1) call start_timer_num(timer%fft_t)
#endif

    iplan=ith+(ipart-1)*run%o_nth
    
!    call sfftw_execute(extraF(iplan));
  data(:,:,:,:,ith)=data(:,:,:,:,ith)*in123
#ifdef SEP_TIMER
       if(run%m_ith==0 .and. ith==1) call stop_timer_num(timer%fft_t)
#endif

 end subroutine


  !----------------------------------------------------------------
  !! inverse FFT
  subroutine weiift_e(ith,ipart,data)
    integer, intent(in) ::  ith,ipart
    complex, dimension(:,:,:,:,:), pointer :: data
    integer :: imx,imy,iplan,nd(4),i1,i2,i3,i4
#ifdef DEBUG
    character(len=128), parameter :: unit='weiift'
    if(run%depar) call in(unit)
#endif
#ifdef SEP_TIMER
       if(run%m_ith==0 .and. ith==1) call start_timer_num(timer%fft_t)
#endif

    iplan=ith+(ipart-1)*run%o_nth
    call sfftw_execute(extraI(iplan))
   data(:,:,:,:,ith)=data(:,:,:,:,ith)*in123
#ifdef SEP_TIMER
       if(run%m_ith==0 .and. ith==1) call stop_timer_num(timer%fft_t)
#endif
#ifdef DEBUG
    if(run%depar) call out(unit)
#endif
  end subroutine weiift_e




  !----------------------------------------------------------------
  !! forward FFT
  subroutine weifft(iws,izs,ith,data)
    integer, intent(in) :: iws,ith,izs
    complex, dimension(:,:,:,:,:) :: data
    integer :: imx,imy,ndim
    integer :: iplan,i3,i1,n1,n2,i2,i4
    integer :: nd(4),nf(4)
#ifdef DEBUG
    character(len=128), parameter :: unit='weifft'
    if(run%depar) call in(unit)
#endif
#ifdef SEP_TIMER
       if(run%m_ith==0 .and. ith==1) call start_timer_num(timer%fft_t)
#endif
    call sfftw_execute(planF(iws))
  data(:,:,:,:,iws)=data(:,:,:,:,iws)*in123
#ifdef SEP_TIMER
       if(run%m_ith==0 .and. ith==1) call stop_timer_num(timer%fft_t)
#endif

 end subroutine


  !----------------------------------------------------------------
  !! inverse FFT
  subroutine weiift(iws,izs,ith,data)
    integer, intent(in) :: iws, ith,izs
    complex, dimension(:,:,:,:,:), pointer :: data
    integer :: imx,imy,iplan,nd(4),i1,i2,i3,i4
#ifdef DEBUG
    character(len=128), parameter :: unit='weiift'
    if(run%depar) call in(unit)
#endif
#ifdef SEP_TIMER
       if(run%m_ith==0 .and. ith==1) call start_timer_num(timer%fft_t)
#endif

    call sfftw_execute(planI(iws))
   data(:,:,:,:,iws)=data(:,:,:,:,iws)*in123
#ifdef SEP_TIMER
       if(run%m_ith==0 .and. ith==1) call stop_timer_num(timer%fft_t)
#endif
#ifdef DEBUG
    if(run%depar) call out(unit)
#endif
  end subroutine weiift



end module wei_fft
