module wei_type
  !! WEI type definitions
  use wei_util

  !---------------
  implicit none

  type down_block
    real, pointer    :: w(:)  !frequency in this block
    real, pointer    :: dz(:) !sampling for this block
    integer,pointer  :: iz_s(:)  !what depth these represent
  end type 
   





!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!OLD!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  !----------------------------------------------------------------
  type weslow_comp
     character(len=512) :: tag_0  !non-local tag (actual input/output)
     character(len=512) :: tag    
     character(len=512) :: tag_local,tag_var
     character(len=128) :: from
     integer            :: bites,esize
     logical            :: velocity
     type(sep3d)        :: struct

     !! block binary array
     real, dimension(:,:,:),     pointer :: bin !slowness (mx,my,z)

  end type weslow_comp
  !----------------------------------------------------------------
  type weslow
   type(weslow_comp) :: s_g,s_s
   type(weslow_comp) :: s1,s2
   logical            :: conv_wave 
   complex, dimension(:,:,:,:,:), pointer :: pba !slowness (mx,my,hx,hy,nzs)
   real, dimension(:,:), pointer :: pba_s !slowness (mx,my)
  end type weslow

  !----------------------------------------------------------------
  type wedata
     character(len=512) :: tag_0
     character(len=512) :: tag
     character(len=128) :: from
     integer            :: bites
     type(axis)         :: aw_local

     !! block binary array
     complex, dimension(:,:,:,:,:), pointer :: bin
  end type wedata
  !----------------------------------------------------------------
  !----------------------------------------------------------------  
  type weimag
     character(len=512) :: tag_0
     character(len=512) :: tag,tag_var
     character(len=127) :: from
     integer            :: bites
     integer            :: esize
     integer            :: ifirst(5),ilast(5)

     !! block binary array
     complex, dimension(:,:,:,:,:), pointer :: bin
  end type weimag
  !----------------------------------------------------------------
  !----------------------------------------------------------------
  type wewfld
     character(len=512) :: tag
     character(len=128) :: from
     integer            :: bites
  end type wewfld
  !----------------------------------------------------------------


  !----------------------------------------------------------------
  type wekmap
     real,    dimension(:),         pointer :: kmx,kmy,khx,khy
     real,    dimension(:,:),       pointer :: ksx,ksy,krx,kry !! f(m,h)
  end type wekmap
  !----------------------------------------------------------------
  !----------------------------------------------------------------
  type wexmap
     real,    dimension(:),         pointer :: mx,my,hx,hy
     real,    dimension(:,:),       pointer :: sx,sy,rx,ry
  end type wexmap
  !----------------------------------------------------------------
  type slowmapthread
     integer, dimension(:,:,:,:,:),   pointer :: si      !! f(mx,my,hx,hy,z)
     integer, dimension(:), pointer           :: nrs     !! f(z)
     real,    dimension(:,      :),   pointer :: sz,bound
     logical :: source
  end type
  !----------------------------------------------------------------
  type weslowmap
     !! FKop slowness
     real,    dimension(:,      :),   pointer :: sz_s,sz_r,bound_r,bound_s !! f(z,nfk)
     !! Number of reference slownesses
     integer, dimension(:), pointer           :: nrs_s,nrs_r     !! f(z)
     !! FXop slowness interpolation map
     integer, dimension(:,:,:,:,:),   pointer :: si_r      !! f(mx,my,hx,hy,z)
     integer, dimension(:,:,:,:,:),   pointer :: si_s      !! f(mx,my,hx,hy,z)
     type(slowmapthread),pointer :: th(:)
  end type weslowmap
  !----------------------------------------------------------------



end module wei_type
