module wei_xmap
  !! X-domain mapping

  use wei_run
  use wei_down_type
  use wei_type
  !---------------
  implicit none

  !! !!!!!!!!!!!!!!!!!!!!!!!!!!!!
  type(wexmap), public :: xmap
  !! !!!!!!!!!!!!!!!!!!!!!!!!!!!!

contains
  !----------------------------------------------------------------
  subroutine weixmap_init()
    integer :: imx,imy,ihx,ihy
    integer :: er
#ifdef DEBUG
    character(len=128), parameter :: unit='weixmap_init'
    if(run%debug) call in(unit)
#endif

    !! mx
    allocate(xmap%mx(down%wsep%n(1)),stat=er)
    call add_mem(size(xmap%mx))
    if(er/=0) call seperr('cant allocate mx')
    do imx=1,down%wsep%n(1)
       xmap%mx(imx) = down%wsep%o(1) + (imx-1)* down%wsep%d(1)
    end do

    !! my
    allocate(xmap%my(down%wsep%n(2)),stat=er)
    call add_mem(size(xmap%my))
    if(er/=0) call seperr('cant allocate my')
    do imy=1,down%wsep%n(2)
       xmap%my(imy) = down%wsep%o(2) + (imy-1)* down%wsep%d(2)
    end do

    !! hx
    allocate(xmap%hx(down%wsep%n(3)),stat=er)
    call add_mem(size(xmap%hx))
    if(er/=0) call seperr('cant allocate hx')
    do ihx=1,down%wsep%n(3)
       xmap%hx(ihx) = down%wsep%o(3) + (ihx-1)* down%wsep%d(3)
    end do

    !! hy
    allocate(xmap%hy(down%wsep%n(4)),stat=er)
    call add_mem(size(xmap%hy))
    if(er/=0) call seperr('cant allocate hy')
    do ihy=1,down%wsep%n(4)
       xmap%hy(ihy) = down%wsep%o(4) + (ihy-1)* down%wsep%d(4)
    end do

    !! sx,rx
    allocate(xmap%sx(down%wsep%n(1),down%wsep%n(3)),stat=er)
    call add_mem(size(xmap%sx))
    if(er/=0) call seperr('cant allocate sx')
    allocate(xmap%rx(down%wsep%n(1),down%wsep%n(3)),stat=er)
    call add_mem(size(xmap%rx))
    if(er/=0) call seperr('cant allocate rx')
    do ihx=1,down%wsep%n(3)
       do imx=1,down%wsep%n(1)
          xmap%sx(imx,ihx) = xmap%mx(imx) - xmap%hx(ihx)
          xmap%rx(imx,ihx) = xmap%mx(imx) + xmap%hx(ihx)
       end do
    end do

    !! sy,ry
    allocate(xmap%sy(down%wsep%n(2),down%wsep%n(4)),stat=er)
    call add_mem(size(xmap%sy))
    if(er/=0) call seperr('cant allocate sy')
    allocate(xmap%ry(down%wsep%n(2),down%wsep%n(4)),stat=er)
    call add_mem(size(xmap%ry))
    if(er/=0) call seperr('cant allocate ry')
    do ihy=1,down%wsep%n(4)
       do imy=1,down%wsep%n(2)
          xmap%sy(imy,ihy) = xmap%my(imy) - xmap%hy(ihy)
          xmap%ry(imy,ihy) = xmap%my(imy) + xmap%hy(ihy)
       end do
    end do

#ifdef DEBUG
    if(run%debug) call out(unit)
#endif
  end subroutine weixmap_init
  !----------------------------------------------------------------
end module wei_xmap
